<?php
//<meta http-equiv="Content-type" content="text/html; charset=iso-8859-2" />
//<meta name="Author" content="Sebastian Marek, Daniel Bargie" />
// +----------------------------------------------------------------------+
// | Sklep Internetowy												  	  |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Daniel Bargie, Sebastian Marek 				  |
// +----------------------------------------------------------------------+


//Zaadowanie niezbdnych moduw
if (PEAR::isError($err = $appCore->loadModule('Forms'))){echo($appCore->getLastErrorMessage()); exit;}

//Funkcja przygotowywuje formularz
function prepareForm() {
	global $appCore, $formObj, $smarty;
	
	//Wywietlanie podsumowania zamwienia
	$titleMsg = $appCore->getMessage('publicorder', 'title');
	$smarty->assign('operationTitle', $titleMsg['VALUE']);
		
	//Podsumowanie zawartoci koszyka
	$totalvaluenetto = $appCore->getMessage('basket', 'totalvaluenetto', array(sprintf('%.2f', $_SESSION['Basket']->getTotalPriceNetto())));
	$smarty->assign('totalvaluenetto', $totalvaluenetto['VALUE']);
	$totalvaluebrutto = $appCore->getMessage('basket', 'totalvaluebrutto', array(sprintf('%.2f', $_SESSION['Basket']->getTotalPriceBrutto())));
	$smarty->assign('totalvaluebrutto', $totalvaluebrutto['VALUE']);
	
	//Przygotowanie sownikw-------------------------------------------
		if (PEAR::isError($err = $appCore->loadModule('DeliveryType'))){echo($appCore->getLastErrorMessage()); exit;}
		//if (PEAR::isError($err = $appCore->loadModule('OrderStatus'))){echo($appCore->getLastErrorMessage()); exit;}
		if (PEAR::isError($err = $appCore->loadModule('PaymentType'))){echo($appCore->getLastErrorMessage()); exit;}
		//if (PEAR::isError($err = $appCore->loadModule('Currency'))){echo($appCore->getLastErrorMessage()); exit;}
		
		
			//Sownik sposobu dostarczenia
			$dtparam[] = array('null', 'Wybierz sposb dostarczenia');
			DeliveryType::prepareComboBoxValues($dtparam);
			$formObj->setValueArray('delivery_type', $dtparam);
			
			//Sownik sposobu patnoci
			$ptparam[] = array('null', 'Wybierz sposb patnoci');
			PaymentType::prepareComboBoxValues($ptparam);
			$formObj->setValueArray('payment_type', $ptparam);
			
			//Sownik wojewdztw
			$stsel = &$_SESSION['CurrentUser']->_address[0]->getState();
			$state = NULL; State::prepareComboBoxValues($state, TRUE, $stsel->getId());
			$formObj->setValueArray('state', $state);

			//Sownik pastw
			$crtsel = &$_SESSION['CurrentUser']->_address[0]->getCountry();
			$country = NULL; Country::prepareComboBoxValues($country, TRUE, $crtsel->getId());
			$formObj->setValueArray('country', $country);
		//Przygotowanie sownikw-------------------------------------------
		
	$smarty->assign_by_ref('form', $formObj);
}

//Czy biecy uytkownik posiada status klienta
if ($_SESSION['CurrentUser']->getType()=='P') {
	
	//Czyszczenie ostatniego bdu aby sprawdzi czy podczas tworzenia obiektu 
	//formularza nie zosta wygenrowany bd
	$appCore->clearLastErrorMessage();
	$formObj = new Forms('logonform.xml');
	if($appCore->getLastErrorMessage()!='') {echo($appCore->getLastErrorMessage()); exit;}

	$smarty->assign_by_ref('form', $formObj);
	
	$titleMsg = $appCore->getMessage('basket', 'title');

	//
	$subtitle = $appCore->getMessage('basket', 'subtitle');
	$smarty->assign('subtitle', $subtitle['VALUE']);
	
	$smarty->assign('operationTitle', $titleMsg['VALUE']);
	//Sprawdzenie czy produkt o podanym id istnieje
	if (isset($_GET['prodid'])) {
	
		if(PEAR::isError($_SESSION['Basket']->addProduct($_GET['prodid']))) {
			$result = $appCore->getMessage('basket', 'operror');
			$smarty->assign('message', $result['VALUE'].' <span style="color:#FF0000">'.$appCore->getLastErrorMessage().'</span>');
		} else {
			//Produkt istnieje. Pruba dodania produktu do koszyka
			
			$result = $appCore->getMessage('basket', 'opok');
			$smarty->assign('message', $result['VALUE']);
		}
	}

	$publicContent = 'logonform.tpl';
} else {

	//Dokument do wywietlenia
	$publicContent = 'createorder.tpl';
	
	//Tytu w dokumencie
	$titleMsg = $appCore->getMessage('publicorder', 'title');
	$smarty->assign('operationTitle', $titleMsg['VALUE']);
	
	$appCore->clearLastErrorMessage();
	$formObj = new Forms('placeorder/placeorder.xml');
	if($appCore->getLastErrorMessage()!='') {echo($appCore->getLastErrorMessage()); exit;}
			
	//Czy zoono zamwienie, czy dopiero jest wywietlane podsumowanie zamwienia
	if(isset($_POST['submit'])) {
	
		//Walidacja danych z formularza
		$resArray = NULL; $formObj->checkForm($resArray);
		if(count($resArray)!=0) {
			prepareForm();
		} else {
		
			//Formularz zosta poprawnie zwalidowany
			//Przygotowywanie tablicy asocjacyjnej z danymi adresowymi 
			//do zamwienia
			$ordAddr['dt']          = $_POST['delivery_type'];
			$ordAddr['pt']          = $_POST['payment_type'];
			$ordAddr['astrnm']      = $_POST['address_streetname'];
			$ordAddr['astrnum']     = $_POST['address_streetnr'];
			$ordAddr['ahomenum']    = $_POST['address_homenr'];
			$ordAddr['acity']       = $_POST['address_city'];
			$ordAddr['azip']        = $_POST['address_zip'];
			$ordAddr['astate']      = $_POST['address_state'];
			$ordAddr['acountry']    = $_POST['address_country'];
			
			//Prawdopodobnie zoono zamwienie
			if (!$_SESSION['Basket']->getBasket()) {
				//Informacja dla uytkownika o bdzie
				$errorMsg = $appCore->getMessage('publicorder', 'errormsg');
				$smarty->assign('message', '<span style="color:#FF0000">'.$errorMsg['VALUE'].'</span>');
			
			} else {
				//Proces skadania zamwienia
				if(PEAR::isError($result = $_SESSION['Basket']->placeOrder($ordAddr))) {
					//Proces nie powid si
					$smarty->assign('message', '<span style="color:#FF0000">'.$appCore->getLastErrorMessage().'</span>');
				} else {
					//Proces powid si
					$message = $appCore->getMessage('publicorder', 'orderok');
					$smarty->assign('message', $message['VALUE']);
				}
			}
		
		}
	} else {
		prepareForm();
				
		$addr = $_SESSION['CurrentUser']->_address[0];
		$formObj->setValueArray('streetname', $addr->getStreetName());
		$formObj->setValueArray('streetnr', $addr->getStreetNr());
		$formObj->setValueArray('homenr', $addr->getHomeNr());
		$formObj->setValueArray('city', $addr->getCity());
		$formObj->setValueArray('zip', $addr->getZip());
		$formObj->setValueArray('phone', $addr->getPhone());
		
		//Obiekt adresu
		
		//Dokument do wysania
		$publicContent = 'createorder.tpl';
	}
}

?>